<?php

	#**********************************************
	# Amazon Web Services // Original Credit = php9.com Calin Uioreanu
	#**********************************************
	
	#**********************************************
	# Change history
	# ==============
	# 10/10/2007 - WebDevBoost.co.uk
	#
	#**********************************************
	# Description
	# ===========
	# The script was originally developed in 2002 but has been adapted and cleaned for better viewing and return.
	# The idea here is to plug and play... but mainly adapt it to what you feel is best
	#**************************************************************************************************


	#/ Configuration
	require_once('func/config.inc.php');

	#/ Calling webservice class
	require_once('func/class.inc.php');
	
	#/ If no search we set search for PHP
	if (!$_GET['Search']) 
	{
		$_GET['Search'] 	= 'PHP';
		$_GET['Mode'] 		= 'books';
		$_GET['Mode'] 		= 'pmrank';
	}

	##/ Setting up search form
	
	echo "<form method=\"get\">";
	echo "Search for <input type=\"text\" name=\"Search\" value=\"".htmlspecialchars($_GET['Search'])."\"> in ";
	
	echo "<select name=\"Mode\">";
		foreach ($arModes as $sMode => $sDisplay) 
		{
			echo "<option value=\"". $sMode ."\"";
			if ($sCurrentMode == $sMode) { echo " selected"; }
			echo ">". $sDisplay ."</option>\n";
		}
	echo "</select> sorted by ";
	
	echo "<select name=\"SortBy\">";
		foreach ($arModeSortType[$sCurrentMode] as $sModeSortType => $sDisplay) 
		{
			echo "<option value=\"". $sModeSortType ."\"";
			if ($sCurrentModeSortType == $sModeSortType) { echo ' selected'; }
			echo ">". $sDisplay ."</option>";
		}
	echo "</select> <input type=\"submit\" value=\"Go\">";
	
	echo "</form>";
	
	##/ End of search form


	flush();


	#/ Starting class
	$oAmazon = new Amazon_WebService();

	#/$oAmazon->fp = fopen ($sUrl, 'r');
	if (!$oAmazon->setInputUrl($sUrl, 20)) 
	{
		die ('Cannot open input file. exiting..' . '<a href='. $sUrl .'>@</a>');
	}
	
	#/ Passing output into layer for formatting
	$oAmazon->sTemplate = 'tpl/search_template.php';
	
	if (!$oAmazon->parse()) 
	{
		die ('XMLParse failed');
	}
	
	$iTotalResuls 	= (int) $oAmazon->arAtribute['TotalResults'];
	$iTotalPages 	= (int) $oAmazon->arAtribute['TotalPages'];

	echo "<p> Displayed ". (int) $oAmazon->iNumResults ." results out of " . $iTotalResuls .".</p>";	
	
	##/ Setting pages
	echo "<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\"><tr><th scope=\"col\">";
		$r=1; for($i=0; $i < $iTotalPages; $i++)
		{
			echo '<a href="?Search='.strip_tags($_GET[Search]).'&Mode='.strip_tags($_GET[Mode]).'&SortBy='.strip_tags(urlencode($_GET[SortBy])).'&page='.$r.'">'.$r.'</a> | '; $r++;
		}
	echo "</th></tr></table>";
	



	#/ DEBUGGING: XML source 
	//echo '<a href='. $sUrl .'>@</a>';

?>